from db_config.db import database
import math
import uuid
from datetime import datetime
import re

def bibliography_inner_search(regex_keywords,req_type):
    plants = {"plants" : {"$in": regex_keywords}, "type": req_type}
    birds = {"birds" : {"$in": regex_keywords}, "type": req_type}
    mammals = {"mammals" : {"$in": regex_keywords}, "type": req_type}
    reptile = {"amphibian_and_reptile" : {"$in": regex_keywords}, "type": req_type}
    fishs = {"fishs" : {"$in": regex_keywords}, "type": req_type}
    insects = {"insects" : {"$in": regex_keywords}, "type": req_type}
    fungi = {"fungi_and_lichen" : {"$in": regex_keywords}, "type": req_type}
    micro = {"microorganisms" : {"$in": regex_keywords}, "type": req_type}
    paleontology = {"paleontology" : {"$in": regex_keywords}, "type": req_type}
    geology_geography = {"geology_and_geography" : {"$in": regex_keywords}, "type": req_type}
    environmental_sciences = {"environmental_sciences" : {"$in": regex_keywords}, "type": req_type}
    medicine = {"medicine" : {"$in": regex_keywords}, "type": req_type}
    anthropology = {"anthropology" : {"$in": regex_keywords}, "type": req_type}
    sociology = {"sociology" : {"$in": regex_keywords}, "type": req_type}
    political_sciences = {"political_sciences" : {"$in": regex_keywords}, "type": req_type}
    culture = {"culture" : {"$in": regex_keywords}, "type": req_type}
    agriculture = {"agriculture" : {"$in": regex_keywords}, "type": req_type}
    horticulture = {"horticulture" : {"$in": regex_keywords}, "type": req_type}
    husbandary = {"husbandary" : {"$in": regex_keywords}, "type": req_type}
    res = list(database["bibliography"].find(
            plants, {"_id": 0,"type":0})) 

    if len(res) < 10:
        keyword_res = list(
            database["bibliography"].find(birds, {"_id": 0,"type":0 }))
        res = res + [i for i in keyword_res if i not in res]
        keyword_res1 = list(
            database["bibliography"].find(mammals, {"_id": 0  }))
        res = res + [i for i in keyword_res1 if i not in res]
        keyword_res2 = list(
            database["bibliography"].find(reptile, {"_id": 0  }))
        res = res + [i for i in keyword_res2 if i not in res]
        keyword_res3 = list(
            database["bibliography"].find(fishs, {"_id": 0  }))
        res = res + [i for i in keyword_res3 if i not in res]
        keyword_res4 = list(
            database["bibliography"].find(insects, {"_id": 0  }))
        res = res + [i for i in keyword_res4 if i not in res]
        keyword_res5 = list(
            database["bibliography"].find(fungi, {"_id": 0  }))
        res = res + [i for i in keyword_res5 if i not in res]
        keyword_res6 = list(
            database["bibliography"].find(micro, {"_id": 0  }))
        res = res + [i for i in keyword_res6 if i not in res]
        keyword_res7 = list(
            database["bibliography"].find(paleontology, {"_id": 0  }))
        res = res + [i for i in keyword_res7 if i not in res]
        keyword_geology = list(
            database["bibliography"].find(geology_geography, {"_id": 0  }))
        res = res + [i for i in keyword_geology if i not in res]
        keyword_evs = list(
            database["bibliography"].find(environmental_sciences, {"_id": 0  }))
        res = res + [i for i in keyword_evs if i not in res]
        keyword_medicine = list(
            database["bibliography"].find(medicine, {"_id": 0  }))
        res = res + [i for i in keyword_medicine if i not in res]
        keyword_anthropology = list(
            database["bibliography"].find(anthropology, {"_id": 0  }))
        res = res + [i for i in keyword_anthropology if i not in res]
        keyword_sociology = list(
            database["bibliography"].find(sociology, {"_id": 0  }))
        res = res + [i for i in keyword_sociology if i not in res]
        keyword_political_sciences = list(
            database["bibliography"].find(political_sciences, {"_id": 0  }))
        res = res + [i for i in keyword_political_sciences if i not in res]
        keyword_culture = list(
            database["bibliography"].find(culture, {"_id": 0  }))
        res = res + [i for i in keyword_culture if i not in res]
        keyword_agriculture = list(
            database["bibliography"].find(agriculture, {"_id": 0  }))
        res = res + [i for i in keyword_agriculture if i not in res]
        keyword_agriculture = list(
            database["bibliography"].find(agriculture, {"_id": 0  }))
        res = res + [i for i in keyword_agriculture if i not in res]
        keyword_horticulture = list(
            database["bibliography"].find(horticulture, {"_id": 0  }))
        res = res + [i for i in keyword_horticulture if i not in res]
        keyword_husbandary = list(
            database["bibliography"].find(husbandary, {"_id": 0  }))
        res = res + [i for i in keyword_husbandary if i not in res]
    return res

def without_keys(d, keys):
    return {x: d[x] for x in d if x not in keys}    

def excel_to_json_product_service_solutions(xls,no):

    df3 = xls.parse(xls.sheet_names[no])
    # remove col that have nan value
    df3 = df3.dropna(axis='columns', how='all')
    # df3=df3.drop(df3.columns.difference(['Unnamed: 0','Unnamed: 1','Unnamed: 2']), 1, inplace=True)
    # df3=df3.fillna('')

    # print(df3,'CHECKED 1')
    if 'Unnamed: 2' in df3.columns:
        print('exists')
        pass

    else: return []    

    df3 = df3[['Unnamed: 0', 'Unnamed: 1', 'Unnamed: 2']]
    # print(df3,'checked 1')
    df3 = df3[df3.isnull().sum(axis=1) < 3]
    # print(df3,'checked 2')
    df3 = df3.set_index('Unnamed: 0').T.to_dict('list')
    # print(df3,'checked 3')

    # print(df3)

    product_list = []
    product_dict = {}
    tech_dict = {}
    tech_list = []
    main_tech_list = []

    for key, value in df3.items():
        # print(key, '->', value[0])
        if math.isnan(key):
            #  null occurs
            # print(key,'if')
            if value[0] in ['Technology', 'Capabilities']:
                # print(value[0])
                tech_keys = 'name' if value[0] in 'Technology' else 'tech_capability'
                # converting string into list
                tech_values = value[1] if type(
                    value[1]) == str else '' if math.isnan(value[1]) else value[1]
                if tech_keys == 'tech_capability':
                    tech_values = value[1].split(
                        ',') if len(value[1]) > 0 else ''

                if tech_keys in tech_dict and tech_dict is not {}:
                    tech_list.append(tech_dict)
                    tech_dict = {}

                tech_dict[tech_keys] = tech_values

            else:
                # print(value[1],'else')
                product_dict[value[0]] = value[1] if type(
                    value[1]) == str else '' if math.isnan(value[1]) else value[1]
        else:
            # for no. occurs
            # print(key,'else')
            if key != float(1.0):
                tech_list.append(tech_dict)
                main_tech_list.append(tech_list)

                tech_list = []
                tech_dict = {}

                product_list.append(product_dict)
                product_dict = {}

            product_dict[value[0]] = value[1] if type(
                value[1]) == str else '' if math.isnan(value[1]) else value[1]

    product_list.append(product_dict)
    tech_list.append(tech_dict)
    main_tech_list.append(tech_list)

    # print(main_tech_list)
    # print(product_list)
    refined_product_list = []

    for i, product_dict in enumerate(product_list):
        temp_dict = {
            "name": product_dict['Name'],
            "url": product_dict['Website URL'],
            "about_product": product_dict["Brief Description"],
            "technology_type": main_tech_list[i]
        }
        refined_product_list.append(temp_dict)

    return refined_product_list



def excel_to_json_patent_recognition(xls,no,sheet_name):

    df6 = xls.parse(xls.sheet_names[no])
    if 'Unnamed: 2' in df6.columns:
        print('exists')
        pass

    else: return []  
    df6 = df6[['Unnamed: 0', 'Unnamed: 1', 'Unnamed: 2']]
    df6 = df6[df6.isnull().sum(axis=1) < 3]
    df6 = df6.set_index('Unnamed: 0').T.to_dict('list')

    # print(df6)

    sheet_dict = {}
    sheet_list = []

    for key, value in df6.items():
        # print(key, '->', value[0])

        if value[0] in sheet_dict and sheet_dict is not {}:
            sheet_list.append(sheet_dict)
            sheet_dict = {}

        sheet_dict[value[0]] = value[1] if type(
            value[1]) == str else '' if math.isnan(value[1]) else value[1]

    sheet_list.append(sheet_dict)


    for ele in sheet_list:
        if sheet_name == 'patent':
            ele['title']=ele.pop('Title')
            ele['url']=ele.pop('URL')
        else :    
            ele['content']=ele.pop('Content')
            ele['year']=ele.pop('Year')

    return sheet_list

def create_unique_object_id():
    unique_object_id = "RA_{uuid}".format(uuid=uuid.uuid4())
    return unique_object_id

def add_notification_content(entity, content_type, new_offerings=[]):
    data = {
        "name": entity["name"],
        "id": entity["id"],
        "content_type": content_type,
        "created_at": datetime.now(),
        "sent": False,
        "read": False
    }

def form_validator(data):
    r = list()
    # r.append(2 <= len(data['name']) <= 100)
    error_messages = []
    # entity_name_valid_status = 2 <= len(data['name']) <= 50
    # r.append(entity_name_valid_status)
    # if not entity_name_valid_status:
    #     error_messages.append(name_not_valid)
    p = re.compile('(http(s)?://.)?(www\.)?[-a-zA-Z0-9@:%._+~#=]{2,256}\.[a-z]{2,6}([-a-zA-Z0-9@:%_+.~#?&/=]*)')
    url_valid_status = p.match(data['url'])
    r.append(url_valid_status)
    if not url_valid_status:
        error_messages.append(url_not_valid)
    # for tech_type in data['technology_type']:
    #     tech_capability_valid_status = len(tech_type['tech_capability']) > 0
    #     r.append(tech_capability_valid_status)
    #     if not tech_capability_valid_status:
    #         error_messages.append(empty_tech_capability)
    if 'name' in data and len(data['name']) > 0:
        print(data['name'],'check 1')
        reg = "([A-Za-z .]*$)"
        pat = re.compile(reg)
        mat = pat.match(data['name'])
        print(pat,data['name'],'check 2')
        # **************** TODO *****************
        # if mat:
        #     r.append(True)
        # else:
        #     r.append(False)
        #     error_messages.append(not_valid_name)
        
        r.append(True)
    if 'about' in data and len(data['about']) > 0:
        about_valid_status = 120 <= len(data['about'])
        r.append(about_valid_status)
        if not about_valid_status:
            error_messages.append(about_not_valid)
    if 'pincode' in data and len(data['pincode']) > 0:
        p = re.compile('^\d{6}$')
        if p.match(data['pincode']):
            r.append(True)
        else:
            r.append(False)
            error_messages.append(pincode_not_valid)
    if 'contact_person' in data:
        # if 'email' in data['contact_person'] and len(data['contact_person']['email']) > 0:
        #
        #     if "@" in data['contact_person']['email']:
        #         r.append(True)
        #     else:
        #         r.append(False)
        #         error_messages.append(email_not_valid)
        # else:
        #     r.append(True)
        #     error_messages.append(empty_email)
        # if 'number' in data['contact_person'] and len(data['contact_person']['number']) > 0:
        #     p = re.compile('^(\+)?((\d){0,4})([-\s])?(\d{6,11})$')
        #     number = data['contact_person']['number'].strip()
        #     if p.match(number):
        #         r.append(True)
        #     else:
        #         r.append(False)
        #         error_messages.append(number_not_valid)
            # name_valid_status = 2 <= len(data['contact_person']['name']) <= 50
            # r.append(name_valid_status)
            # if not name_valid_status:
            #     error_messages.append(name_not_valid)
        if 'facebook' in data['contact_person'] and len(data['contact_person']['facebook']) > 0:
            p = re.compile('^(https?://)?(www\.)?facebook.com/[a-zA-Z0-9/_.]{2,256}')
            if p.match(data['contact_person']['facebook']):
                r.append(True)
            else:
                r.append(False)
                error_messages.append(facebook_url_not_valid)
        if 'linkedin' in data['contact_person'] and len(data['contact_person']['linkedin']) > 0:
            p = re.compile('^(https?://)?(www\.)?[a-zA-Z0-9/_.]{2,10}linkedin[a-zA-Z0-9/_.]{2,10}/[a-zA-Z0-9-/_.]{2,256}')
            if p.match(data['contact_person']['linkedin']):
                r.append(True)
            else:
                r.append(False)
                error_messages.append(linkedin_url_not_valid)
        if 'twitter' in data['contact_person'] and len(data['contact_person']['twitter']) > 0:
            p = re.compile('^(https?://)?(www\.)?twitter.com/[a-zA-Z0-9/_.]{2,256}')
            if p.match(data['contact_person']['twitter']):
                r.append(True)
            else:
                r.append(False)
                error_messages.append(twitter_url_not_valid)
    if False in r:
        flag = False
    else:
        flag = True
    return flag, error_messages

def track_modifications(old_entity, new_entity):
    # Track Offerings
    new_offerings = track_offerings(old_entity, new_entity)
    new_entity["liked_by"] = old_entity["liked_by"] if "liked_by" in old_entity else []
    add_notification_content(new_entity, content_type="offering", new_offerings=new_offerings)