from django.shortcuts import render
import json
from nltk.util import pr
from pymongo.common import partition_node
from rest_framework.decorators import api_view
from django.core.mail import BadHeaderError, send_mail
from rest_framework import status
from rest_framework.response import Response
from db_config.db import database
from pymongo import MongoClient
from django.core.mail import send_mail
from django.core.mail import EmailMultiAlternatives
from django.template.loader import render_to_string
from api.org_email import*
import re
from nltk.corpus import stopwords
import nltk
import time
from operator import add
from api import methods


# map_url = "https://ladakh-raw-data.s3.ap-south-1.amazonaws.com/biodiversity/plant/map/"

@api_view(['GET'])
def speices_count(request):
    try:
        req_type = request.GET.get("type", "")
        specie_count = methods.speices_count(req_type)
        return Response(status=status.HTTP_200_OK,
                        data={"data": specie_count})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def speices_list(request):
    try:
        req_type = request.GET.get("type", "")
        req_count = request.GET.get("count", "")
        specie_list = methods.speices_list(req_type, req_count)
        return Response(status=status.HTTP_200_OK,
                        data={"data": specie_list})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def test_info(request):
    try:
        req_type = request.GET.get("type", "")
        # creating index
        #index = database["biodiversity"].create_index([('type', 'text')])
        # index2 = database["biodiversity"].create_index([('id', '')])F
        # { partialFilterExpression: { name: { $exists: true } } }
        #print(index, 'index')

        # res = list(database["biodiversity"].find({"$match": {"type": {"$regex": "Acacia", "$options": "i"}}},
        #                                          {"_id": 0}))

        index = database["biodiversity"].create_index([("type", "text")])
        # print(database["biodiversity"].index_information())
        # finding on the basis of request type
        result = list(database["biodiversity"].find(
            {"$text": {"$search": "/^pla"}}, {"_id": 0}))
        '''result = list(database["biodiversity"].aggregate([{
            "$search":{
                "$text":{
                    "$query":"plant",
                    "$path" : "type"
                }
            }
        }]))'''

        regex = list(database["biodiversity"].find({"taxonomy.species":
                                                    {"$regex": req_type, "$options": 'si'}}, {"_id": 0, "taxonomy.species": 1}))

        return Response(status=status.HTTP_200_OK, data=result)

    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['POST'])
def feedback(request):
    try:
        database["feedback"].insert({
            "email": request.data['email'],
            "feedback": request.data['feedback'],
            "page_name": request.data['page_name']
        })
        message = request.data["feedback"]
        email = request.data["email"]
        page_name = request.data["page_name"]
        # print(page_name)
        template_msg = render_to_string(
            'org_email.html', {'message': message, 'email': email, "page_name": page_name})
        msg = EmailMultiAlternatives(subject, template_msg, email_from,
                                     [to])
        msg.content_subtype = "html"
        msg.send()
        return Response(status=status.HTTP_200_OK, data={
            "email": request.data["email"],
            "feedback": request.data["feedback"],
            "page_name": request.data['page_name'],
            'success': True})

    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def specie_detail(request):
    try:
        req_id = request.GET.get("id", "")
        details = dict()
        final_data = dict()
        if len(req_id) != 0:
            final_data = methods.speices_detail(req_id, final_data)
            final_data = methods.species_hier(req_id, final_data)
            details["data"] = final_data
            return Response(status=status.HTTP_200_OK,
                            data=details)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@ api_view(['GET'])
def bibliography_data(request):
    try:
        req_type = request.GET.get("type", "")
        req_element = request.GET.get("element", "")
        #req_page = request.GET.get("page", "")
        bibliography_data = methods.bibliography_data(req_type, req_element)
        return Response(status=status.HTTP_200_OK,
                        data={"data": bibliography_data})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})

@ api_view(['GET'])
def bibliography_pagination(request):
    try:
        req_type = request.GET.get("type", "")
        req_element = request.GET.get("element", "")
        req_page = request.GET.get("page", "")
        bibliography_data = methods.bibliography_data(req_type, req_element,req_page)
        return Response(status=status.HTTP_200_OK,
                        data={"data": bibliography_data})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def bibliography_heir(request):
    try:
        req_type = request.GET.get("type", "")
        bibliography_heir = methods.bibliography_heir(req_type)
        return Response(status=status.HTTP_200_OK,
                        data=bibliography_heir)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@ api_view(['GET'])
def ladakh_data(request):
    try:
        req_type = request.GET.get("type", "")
        if len(req_type) != 0:
            biodiversity_data = list(database["content"].find(
                {'type': req_type}, {"_id": 0}))
            data = dict()
            data["data"] = biodiversity_data[0]

            return Response(status=status.HTTP_200_OK, data=data)
        elif req_type == "team":
            return Response(status=status.HTTP_200_OK, data="data")

        else:
            return Response(status=status.HTTP_200_OK, data={"message": "dont render"})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@ api_view(['GET'])
def specie_images(request):
    try:
        req_id = request.GET.get("id", "")
        if len(req_id) != 0:
            biodiversity_data = database["biodiversity"].find_one(
                {"id": req_id}, {"_id": 0, "specie_images": 1})
            data = dict()
            data["images"] = biodiversity_data["specie_images"]["image_link"]
            return Response(status=status.HTTP_200_OK,
                            data=data)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def search(request):
    try:
        key = request.GET.get("keyword", "")
        keyword = key.capitalize()
        request_type = request.GET.get("type", "")
        group = request.GET.get("group", "")
        if request_type == "biodiversity":
            if len(keyword) != 0 and keyword != "None":
                search_dict = dict()
                search_data = methods.home_search(keyword, request_type, group)
                search_dict["name"] = search_data
                search_dict["request"] = key
                search_dict["request_type"] = request_type
                return Response(status=status.HTTP_200_OK,
                                data=search_dict)
            else:
                return Response(status=status.HTTP_200_OK, data={"message": "not valid"})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@ api_view(['GET'])
def group_content(request):
    try:
        req_type = request.GET.get("type", "")
        print(req_type)
        if len(req_type) != 0:
            content_data = list(database["group_content"].find(
                {'type': req_type}, {"_id": 0}))
            print(content_data)
            data = dict()
            data["data"] = content_data[0]
            return Response(status=status.HTTP_200_OK, data=data)
        else:
            return Response(status=status.HTTP_200_OK, data={"message": "dont render"})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


# @api_view(['GET'])
# def graph(request):
#     try:
#         req_type = request.GET.get("type", "")
#         if len(req_type) != 0:
#             content_data = database["socioeconomic"].find_one(
#                 {'type': req_type}, {"_id": 0, "type": 0})

#             for i, j in content_data.items():
#                 final_list = list()
#                 for key in j:

#                     value_data = dict()
#                     country = key["country"]
#                     age = key["age"]
#                     if type(age) == str:
#                         age_value = float(age)
#                     value_data["country"] = country
#                     value_data["age"] = age_value

#                     # print(type(value_data["age"]))
#                     final_list.append(value_data)

#             data = final_list
#             return Response(status=status.HTTP_200_OK, data={"data": data})
#         else:
#             return Response(status=status.HTTP_200_OK, data={"message": "dont render"})
#     except Exception as e:
#         print(e)
#         return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


# @api_view(['GET'])
# def socioeconomic(request):
#     try:
#         parent_id = request.GET.get("parent_id", "")
#         req_id = request.GET.get("id", "")
#         if len(req_id) != 0:
#             parent_data = list(database["socioeconomic"].find(
#                 {'id': req_id}, {"_id": 0, "id": 1}))
#             ab = parent_data[0]
#             for i, j in ab.items():
#                 id_value = j
#             child_data = list(database["socioeconomic"].find(
#                 {'parent_id': id_value}, {"_id": 0, "data": 1}))
#             name_list = list()
#             for i in child_data:
#                 name = dict()
#                 name["name"] = i["data"]["name"]
#                 name_list.append(name)

#             return Response(status=status.HTTP_200_OK, data=name_list)
#         else:
#             return Response(status=status.HTTP_200_OK, data={"message": "dont render"})
#     except Exception as e:
#         print(e)
#         return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def taxonomy_list(request):
    try:
        req_type = request.GET.get("type", "")
        req_id = request.GET.get("id", "")
        req_name = request.GET.get("name", "")
        taxa_name = "taxonomy." + req_id         
        species = []
        final_list=list()
        species_count = list()
        if len(req_name)==0:
            response = methods.taxonomy_names(req_id ,taxa_name ,req_type,final_list)
            return response
        else:
            data = list(database["biodiversity"].find(
                {taxa_name: req_name}, {"_id": 0}))
            species_list =list()
            if req_id =="group":
                response = methods.group_names_count(taxa_name,req_name)
                return response   
            elif req_id =="family":
                response = methods.family_names_count(taxa_name,req_name)
                return response   
            elif req_id =="genus":
                response = methods.genus_names_count(req_type,taxa_name,req_name,data,species,species_count,species_list)
                return response

    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def web_misc_update(request):

    try:
        req_type = request.GET.get("type", "")
        print(req_type)

        if req_type == 'visitor':
            visits = database['download_visitor_count'].find_one(
                {"type": "visitor"}, {"_id": 0, "count": 1})['count']

            database['download_visitor_count'].update(
                {"type": "visitor"}, {"$set": {"count": visits+1}})

            data = database['download_visitor_count'].find_one(
                {"type": "visitor"}, {"_id": 0, "count": 1})['count']

            return Response(status=status.HTTP_200_OK,
                            data={"data": data})

        elif req_type == 'biodiversity':
            download = database['download_visitor_count'].find_one(
                {"type": "biodiversity"}, {"_id": 0, "count": 1})['count']

            database['download_visitor_count'].update(
                {"type": "biodiversity"}, {"$set": {"count": download+1}})

            data = database['download_visitor_count'].find_one(
                {"type": "biodiversity"}, {"_id": 0, "count": 1})['count']

            print(data)

            return Response(status=status.HTTP_200_OK,
                            data={"data": data})

        elif req_type == 'bibliography':
            download = database['download_visitor_count'].find_one(
                {"type": "bibliography"}, {"_id": 0, "count": 1})['count']

            database['download_visitor_count'].update(
                {"type": "bibliography"}, {"$set": {"count": download+1}})

            data = database['download_visitor_count'].find_one(
                {"type": "bibliography"}, {"_id": 0, "count": 1})['count']
            
            print(data)

            return Response(status=status.HTTP_200_OK,
                            data={"data": data})

        elif req_type == 'specie':
            download = database['download_visitor_count'].find_one(
                {"type": "specie"}, {"_id": 0, "count": 1})['count']

            database['download_visitor_count'].update(
                {"type": "specie"}, {"$set": {"count": download+1}})

            data = database['download_visitor_count'].find_one(
                {"type": "specie"}, {"_id": 0, "count": 1})['count']

            print(data)

            return Response(status=status.HTTP_200_OK,
                            data={"data": data})

    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def bibliography_search(request):
    try:
        search_key = request.GET.get("keyword", "")
        req_type = request.GET.get("type","") 
        req_element = request.GET.get("group","")  
        response = methods.bibliography_search(search_key,req_type,req_element)
        return response
    except Exception as e:
        print(e)
        data = {"search_key": search_key,
                "key_elements":[]}
        return Response(status=status.HTTP_200_OK, data={"data": data}) 
    
   

@api_view(['GET'])        
def download_pdf_count(re):
    try:

        download_count = list(database['download_visitor_count'].find(
            {"type": {"$in": ["specie", "bibliography", "biodiversity"]}}, {"_id": 0, "count": 1}))

        print(download_count, 'adsadsadsa')
        counts = 0
        for ele in download_count:
            counts += ele['count']

        print(counts)

        return Response(status=status.HTTP_200_OK,
                        data={"data": counts})

    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})


@api_view(['GET'])
def culture_heir(request):
    try:
        req_type = request.GET.get("type", "")
        culture_heir = methods.culture_heir(req_type)
        return Response(status=status.HTTP_200_OK,
                        data=culture_heir)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})
    
    
@ api_view(['GET'])
def culture_data(request):
    try:
        req_type = request.GET.get("type", "")
        req_element = request.GET.get("element", "")
        #req_page = request.GET.get("page", "")
        culture_data = methods.culture_data(req_type, req_element)
        return Response(status=status.HTTP_200_OK,
                        data={"data": culture_data})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})
    

    
@api_view(['GET'])
def wildlifeDepartment_heir(request):
    try:
        req_type = request.GET.get("type", "")
        wildlifeDepartment_heir = methods.wildlifeDepartment_heir(req_type)
        return Response(status=status.HTTP_200_OK,
                        data=wildlifeDepartment_heir)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})
    


    
@ api_view(['GET'])
def introduction_data(request):
    try:
        req_type = request.GET.get("type", "")
        req_element = request.GET.get("element", "")
        #req_page = request.GET.get("page", "")
        wildlife_department_data = methods.introduction_data(req_type, req_element)
        return Response(status=status.HTTP_200_OK,
                        data={"data": wildlife_department_data})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})
    
    
@ api_view(['GET'])
def unionterritory_data(request):
    try:
        req_type = request.GET.get("type", "")
        req_element = request.GET.get("element", "")
        #req_page = request.GET.get("page", "")
        unionterritory_data = methods.unionterritory_data(req_type, req_element)
        return Response(status=status.HTTP_200_OK,
                        data={"data": unionterritory_data})
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})
    
    
@api_view(['GET'])
def unionterritory_heir(request):
    try:
        req_type = request.GET.get("type", "")
        unionterritory_heir = methods.unionterritory_heir(req_type)
        return Response(status=status.HTTP_200_OK,
                        data=unionterritory_heir)
    except Exception as e:
        print(e)
        return Response(status=status.HTTP_404_NOT_FOUND, data={"message": str(e), "success": False})    


    
    
    
