# your_project/nltk_middleware.py
import nltk

class NLTKMiddleware:
    def __init__(self, get_response):
        self.get_response = get_response
        self.is_nltk_setup = False

    def __call__(self, request):
        if not self.is_nltk_setup:
            self.setup_nltk()
        self.is_nltk_setup = True
        return self.get_response(request)

    @staticmethod
    def setup_nltk():
        try:
            nltk.data.find('corpora/stopwords')
            print(nltk.data.find('corpora/stopwords'))
        except LookupError:
            nltk.download('stopwords')
